/// <reference types="node" />
import { FastifyInstance } from 'fastify';
import { IncomingMessage, Server, ServerResponse } from 'http';
import { ObservableInput } from 'rxjs';
interface BotstreamConfig {
    facebookAccessToken: string;
    facebookApiVersion?: string;
    facebookVerifyToken: string;
    port?: number;
}
export declare let globalConfig: BotstreamConfig;
declare function loadSkills<O extends ObservableInput<any>>(...skills: O[]): void;
declare function botstream(config: BotstreamConfig): {
    loadSkills: typeof loadSkills;
    server: FastifyInstance<Server, IncomingMessage, ServerResponse>;
};
export default botstream;
