"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const operators_1 = require("rxjs/operators");
const facebook_messenger_api_client_1 = require("../utils/facebook-messenger-api-client");
function composeTemplate(template) {
    return {
        message: {
            attachment: {
                payload: template,
                type: 'template',
            },
        },
    };
}
function sendGenericTemplate(templateOrFn) {
    return (source) => source.pipe(operators_1.mergeMap(async (ev) => {
        const template = typeof templateOrFn === 'function' ? await templateOrFn(ev) : templateOrFn;
        await facebook_messenger_api_client_1.send(composeTemplate({
            ...template,
            template_type: 'generic',
        }), { senderId: ev.sender.id });
        return ev;
    }));
}
exports.sendGenericTemplate = sendGenericTemplate;
function sendButtonTemplate(templateOrFn) {
    return (source) => source.pipe(operators_1.mergeMap(async (ev) => {
        const template = typeof templateOrFn === 'function' ? await templateOrFn(ev) : templateOrFn;
        await facebook_messenger_api_client_1.send(composeTemplate({
            ...template,
            template_type: 'button',
        }), { senderId: ev.sender.id });
        return ev;
    }));
}
exports.sendButtonTemplate = sendButtonTemplate;
