"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const got_1 = tslib_1.__importDefault(require("got"));
const logger_1 = tslib_1.__importDefault(require("./logger"));
const botstream_1 = require("../botstream");
function send(query, { senderId }) {
    const apiVersion = botstream_1.globalConfig.facebookApiVersion || 'v4.0';
    const apiEndpoint = `https://graph.facebook.com/${apiVersion}/me/messages`;
    const body = {
        recipient: {
            id: senderId,
        },
        ...query,
    };
    return got_1.default(apiEndpoint, {
        body,
        json: true,
        method: 'POST',
        query: { access_token: botstream_1.globalConfig.facebookAccessToken },
    })
        .then(res => res.body)
        .catch(err => {
        logger_1.default.error(err.body.error);
    });
}
exports.send = send;
